Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.27
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.jce.provider
Class JCESecretKeyFactory

    java.lang.Object
      |
      +--javax.crypto.SecretKeyFactorySpi
            |
            +--org.bouncycastle.jce.provider.JCESecretKeyFactory

All Implemented Interfaces:
  PBE

Direct Known Subclasses:
  JCESecretKeyFactory.DES, JCESecretKeyFactory.DESede, JCESecretKeyFactory.DESPBEKeyFactory, JCESecretKeyFactory.PBEKeyFactory

public class JCESecretKeyFactory
extends SecretKeyFactorySpi
implements PBE

Nested Class Summary
`static class` | `JCESecretKeyFactory.DES`
`static class` | `JCESecretKeyFactory.DESede`
`static class` | `JCESecretKeyFactory.DESPBEKeyFactory`
`static class` | `JCESecretKeyFactory.PBEKeyFactory`
`static class` | `JCESecretKeyFactory.PBEWithMD5And128BitAESCBCOpenSSL` PBEWithMD5And128BitAES-OpenSSL
`static class` | `JCESecretKeyFactory.PBEWithMD5And192BitAESCBCOpenSSL` PBEWithMD5And128BitAES-OpenSSL
`static class` | `JCESecretKeyFactory.PBEWithMD5And256BitAESCBCOpenSSL` PBEWithMD5And128BitAES-OpenSSL
`static class` | `JCESecretKeyFactory.PBEWithMD5AndDES` PBEWithMD5AndDES
`static class` | `JCESecretKeyFactory.PBEWithMD5AndRC2` PBEWithMD5AndRC2
`static class` | `JCESecretKeyFactory.PBEWithRIPEMD160` PBEWithHmacRIPEMD160
`static class` | `JCESecretKeyFactory.PBEWithSHA` PBEWithHmacSHA
`static class` | `JCESecretKeyFactory.PBEWithSHA1AndDES` PBEWithSHA1AndDES
`static class` | `JCESecretKeyFactory.PBEWithSHA1AndRC2` PBEWithSHA1AndRC2
`static class` | `JCESecretKeyFactory.PBEWithSHA256And128BitAESBC` PBEWithSHA256And128BitAES-BC
`static class` | `JCESecretKeyFactory.PBEWithSHA256And192BitAESBC` PBEWithSHA256And192BitAES-BC
`static class` | `JCESecretKeyFactory.PBEWithSHA256And256BitAESBC` PBEWithSHA256And256BitAES-BC
`static class` | `JCESecretKeyFactory.PBEWithSHAAnd128BitAESBC` PBEWithSHA1And128BitAES-BC
`static class` | `JCESecretKeyFactory.PBEWithSHAAnd128BitRC2` PBEWithSHAAnd128BitRC2-CBC
`static class` | `JCESecretKeyFactory.PBEWithSHAAnd128BitRC4` PBEWithSHAAnd128BitRC4
`static class` | `JCESecretKeyFactory.PBEWithSHAAnd192BitAESBC` PBEWithSHA1And192BitAES-BC
`static class` | `JCESecretKeyFactory.PBEWithSHAAnd256BitAESBC` PBEWithSHA1And256BitAES-BC
`static class` | `JCESecretKeyFactory.PBEWithSHAAnd40BitRC2` PBEWithSHAAnd40BitRC2-CBC
`static class` | `JCESecretKeyFactory.PBEWithSHAAnd40BitRC4` PBEWithSHAAnd40BitRC4
`static class` | `JCESecretKeyFactory.PBEWithSHAAndDES2Key` PBEWithSHAAnd2-KeyTripleDES-CBC
`static class` | `JCESecretKeyFactory.PBEWithSHAAndDES3Key` PBEWithSHAAnd3-KeyTripleDES-CBC
`static class` | `JCESecretKeyFactory.PBEWithSHAAndIDEA` PBEWithSHAAndIDEA-CBC
`static class` | `JCESecretKeyFactory.PBEWithSHAAndTwofish` PBEWithSHAAndTwofish-CBC
`static class` | `JCESecretKeyFactory.PBEWithTiger` PBEWithHmacTiger

Nested classes inherited from class org.bouncycastle.jce.provider.PBE
`PBE.Util`

Field Summary
`protected java.lang.String` | `algName`
`protected DERObjectIdentifier` | `algOid`

Fields inherited from interface org.bouncycastle.jce.provider.PBE
`MD5, OPENSSL, PKCS12, PKCS5S1, PKCS5S2, RIPEMD160, SHA1, SHA256, TIGER`

Constructor Summary
`protected` | `JCESecretKeyFactory(java.lang.String algName, DERObjectIdentifier algOid)`

Method Summary
`protected SecretKey` | `engineGenerateSecret(java.security.spec.KeySpec keySpec)` Generates a `SecretKey` object from the provided key specification (key material).
`protected java.security.spec.KeySpec` | `engineGetKeySpec(SecretKey key, java.lang.Class keySpec)` Returns a specification (key material) of the given key object in the requested format.
`protected SecretKey` | `engineTranslateKey(SecretKey key)` Translates a key object, whose provider may be unknown or potentially untrusted, into a corresponding key object of this secret-key factory.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### algName

    protected java.lang.String algName

### algOid

    protected DERObjectIdentifier algOid

Constructor Detail

### JCESecretKeyFactory

    protected JCESecretKeyFactory(java.lang.String algName,
                                  DERObjectIdentifier algOid)

Method Detail

### engineGenerateSecret

    protected SecretKey engineGenerateSecret(java.security.spec.KeySpec keySpec)
                                      throws java.security.spec.InvalidKeySpecException

  Description copied from class: `SecretKeyFactorySpi`
  Generates a `SecretKey` object from the provided key specification (key material).

  Specified by:
    `engineGenerateSecret` in class `SecretKeyFactorySpi`
  Parameters:
    `keySpec` - the specification (key material) of the secret key
  Returns:
    the secret key
  Throws:
    `java.security.spec.InvalidKeySpecException` - if the given key specification is inappropriate for this secret-key factory to produce a secret key.

### engineGetKeySpec

    protected java.security.spec.KeySpec engineGetKeySpec(SecretKey key,
                                                          java.lang.Class keySpec)
                                                   throws java.security.spec.InvalidKeySpecException

  Description copied from class: `SecretKeyFactorySpi`
  Returns a specification (key material) of the given key object in the requested format.

  Specified by:
    `engineGetKeySpec` in class `SecretKeyFactorySpi`
  Parameters:
    `key` - the key
    `keySpec` - the requested format in which the key material shall be returned
  Returns:
    the underlying key specification (key material) in the requested format
  Throws:
    `java.security.spec.InvalidKeySpecException` - if the requested key specification is inappropriate for the given key (e.g., the algorithms associated with `key` and `keySpec` do not match, or `key` references a key on a cryptographic hardware device whereas `keySpec` is the specification of a software-based key), or the given key cannot be dealt with (e.g., the given key has an algorithm or format not supported by this secret-key factory).

### engineTranslateKey

    protected SecretKey engineTranslateKey(SecretKey key)
                                    throws java.security.InvalidKeyException

  Description copied from class: `SecretKeyFactorySpi`
  Translates a key object, whose provider may be unknown or potentially untrusted, into a corresponding key object of this secret-key factory.

  Specified by:
    `engineTranslateKey` in class `SecretKeyFactorySpi`
  Parameters:
    `key` - the key whose provider is unknown or untrusted
  Returns:
    InvalidKeyException if the given key cannot be processed by this secret-key factory.
    `java.security.InvalidKeyException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography 1.27
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD